//////////////////////////////////////////////////////////////////////////////
// kbdtest.c                                                                //
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
// includes                                                                 //
//////////////////////////////////////////////////////////////////////////////
#include <gb.h>
#include "kbd.h"

//////////////////////////////////////////////////////////////////////////////
// variables                                                                //
//////////////////////////////////////////////////////////////////////////////
UBYTE buffer[64]; // scancode buffer
UBYTE *start, *end; // pointers
//int keytable1[0x80], keytable2[0x80];

//////////////////////////////////////////////////////////////////////////////
// Test_kbd_handler                                                         //
//////////////////////////////////////////////////////////////////////////////
// quick scancode handler that only puts scancode into a buffer
void Test_kbd_handler(unsigned char scancode)
{
	*end++ = scancode;
	if (end >= buffer+64) end = buffer;
}

//////////////////////////////////////////////////////////////////////////////
// GetScancode                                                              //
//////////////////////////////////////////////////////////////////////////////
// retrieves one scancode from the buffer
unsigned char GetScancode()
{
	unsigned char scancode;
	if (start == end) return 0; // no key detected
	disable_interrupts();
	scancode = *start++;
	if (start >= buffer+64) start = buffer;
	enable_interrupts();
	return scancode;
}

//////////////////////////////////////////////////////////////////////////////
// Test_kbd_handler                                                         //
//////////////////////////////////////////////////////////////////////////////
/*// another example could be...
void Test_kbd_handler(unsigned char scancode)
{
	static int extended = 0;
	if (scancode == K_EXTENDED1)
	{
		extended = 1;
	} else {
		if (extended)
		{
			extended = 0;
			if (scancode > 0x80)
				keytable2[scancode & 0x7F] = 0;
			else
				keytable2[scancode] = 1;
		} else {
			if (scancode > 0x80)
				keytable1[scancode & 0x7F] = 0;
			else
				keytable1[scancode] = 1;
		}
	}
}
*/

//////////////////////////////////////////////////////////////////////////////
// main                                                                     //
//////////////////////////////////////////////////////////////////////////////
void main()
{
	SHOW_BKG;
	
	printf("Keyboard interface\n");
	printf("* = bit 7\n");
	printf("\n");
	
	start = end = buffer;
	InitKeyboard(Test_kbd_handler);
	while (1)
	{
		unsigned char scancode = GetScancode();
		if (scancode & 0x80)
			printf("0x%x *\n", scancode & 0x7F);
		else if (scancode)
			printf("0x%x\n", scancode);
		set_bkg_tiles(19,0,1,1, &kbd_errors);
	}
}
